"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class LinearAlignment(ProtocolElement):
    """
    A linear alignment can be represented by one CIGAR string.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "position",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import ga4gh as ga4gh_3_1_0

        return {
            "cigar": ga4gh_3_1_0.CigarUnit,
            "position": ga4gh_3_1_0.Position,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import ga4gh as ga4gh_3_1_0

        return {
            "org.ga4gh.models.CigarUnit": ga4gh_3_1_0.CigarUnit,
            "org.ga4gh.models.Position": ga4gh_3_1_0.Position,
            "org.ga4gh.models.LinearAlignment": ga4gh_3_1_0.LinearAlignment,
        }

    __slots__ = [
        "position",
        "cigar",
        "mappingQuality",
    ]

    def __init__(
        self,
        position,
        cigar=list,
        mappingQuality=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_0.LinearAlignment model.

        :param position:
            The position of this alignment.
        :type position: Position
        :param cigar:
            Represents the local alignment of this sequence (alignment matches,
            indels, etc)   versus the reference.
        :type cigar: list[CigarUnit]
        :param mappingQuality:
            The mapping quality of this alignment. Represents how likely   the
            read maps to this position as opposed to other locations.
        :type mappingQuality: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.0"
